Index: branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs	(revision 50)
+++ branches/src/ProcessManagement/ProcessManagement/Forms/DataEntry/PurchaseOrderEntry/FrmPurchaseOrderEntryAuxiliary.cs	(revision 51)
@@ -472,193 +914,8 @@
             }
         }
         #endregion
+        // ---------- 注文書よりデータ作成          　↑↑
 
-        #region 工事予算書よりデータを取り込む
-        /// <summary>
-        /// 工事予算書よりデータを取り込む
-        /// </summary>
-        /// <returns></returns>
-        private bool CreateNewOrderData()
-        {
-            IOConstructionBudgetDetail DetailDB = new IOConstructionBudgetDetail();
-            try
-            {
-                // 注文書データ読込
-                string strSQL = DetailDB.CreatePrimarykeyString(m_ConstructionCode);
-                strSQL += " AND CompanyCode <> 0";
-                strSQL += string.Format(" AND COMPANYTYPE <> {0}", (int)CommonDefine.SearchLogDataType.Person);
-                strSQL += " ORDER BY CompanyCode";
-                List<ConstructionBudgetDetail> DetailList = new List<ConstructionBudgetDetail>();
-                if (!DetailDB.SelectAction(strSQL, ref DetailList)) return false;
-                if (DetailList.Count == 0) return false;
-
-                // デフォルトページを削除する
-                this.TabCollections.TabPages.RemoveAt(0);
-
-                int icnt = 0;
-                bool binit = true;
-                int Break_CompanyCode = 0;
-                double Break_Total = 0;
-                List<ConstructionBudgetDetail> SumBuffer = new List<ConstructionBudgetDetail>();
-                foreach (ConstructionBudgetDetail DetailRec in DetailList)
-                {
-                    // 1件目はバッファへセットして処理しない
-                    if (binit)
-                    {
-                        Break_CompanyCode = DetailRec.CompanyCode;
-                        Break_Total = DetailRec.ExecutionAmount;
-                        SumBuffer.Add(DetailRec);
-                        binit = false;
-                        continue;
-                    }
-                    // 会社コードが変わればでデータセットへ行く
-                    if (Break_CompanyCode != DetailRec.CompanyCode)
-                    {
-                        // 協力業者発注合計が30万以上に注文書を発行する
-                        if (Break_Total >= 300000)
-                        {
-                            // ページ追加
-                            PurchaseOrderInputPage inputpage = new PurchaseOrderInputPage();
-                            CreateNewPage(ref inputpage, icnt, (int)CommonDefine.OrderSheetType.SimpleType);
-                            m_TabPageList.Add(inputpage);
-
-                            // グループ５コンボボックスセット
-                            SetInitcmbPersonInCharge(inputpage);
-
-                            // データをセットする
-                            SetConstructionBudget(inputpage, SumBuffer, icnt);
-                            icnt++;
-                        }
-                        // バッファクリア
-                        SumBuffer.Clear();
-                        // ブレイクキーセット
-                        Break_CompanyCode = DetailRec.CompanyCode;
-                        // 協力業者発注合計をクリア
-                        Break_Total = 0;
-                    }
-                    // データ退避
-                    SumBuffer.Add(DetailRec);
-                    // 協力業者発注合計に金額を加算
-                    Break_Total += DetailRec.ExecutionAmount;
-                }
-
-                // 協力業者発注合計が30万以上に注文書を発行する
-                if (Break_Total >= 300000)
-                {
-                    // ページ追加
-                    PurchaseOrderInputPage inputpage = new PurchaseOrderInputPage();
-                    CreateNewPage(ref inputpage, icnt, (int)CommonDefine.OrderSheetType.SimpleType);
-                    m_TabPageList.Add(inputpage);
-
-                    // データをセットする
-                    SetConstructionBudget(inputpage, SumBuffer, icnt);
-                    icnt++;
-                }
-                //// 支払条件の初期設定
-                //if (!GetConstructionTypeToExecNo())
-                //{
-                //    // 注文書種別(簡易版)
-                //    radioButton1.Checked = true;
-                //}
-                //else
-                //{
-                //    // 注文書種別(正規版)
-                //    radioButton2.Checked = true;
-                //}
-                EventArgs e = new EventArgs();
-                radioButton1_CheckedChanged((object)radioButton1, e);
-
-                return true;
-            }
-            catch (System.Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-                return false;
-            }
-            finally
-            {
-                DetailDB.close(); DetailDB = null;
-            }
-        }
-        #endregion
-
-        #region 工事予算書データより画面へデータをセットする
-        /// <summary>
-        /// 工事予算書データより画面へデータをセットする
-        /// </summary>
-        /// <param name="inputpage"></param>
-        /// <param name="DetailRec"></param>
-        private bool SetConstructionBudget(PurchaseOrderInputPage inputpage, List<ConstructionBudgetDetail> DetailList, int PageCount)
-        {
-            try
-            {
-                // 協力会社コード
-                inputpage.OrderCompanyCode = DetailList[0].CompanyCode;
-                // 協力会社名セット
-                inputpage.EntryTab.Text = DetailList[0].CompanyName;
-                inputpage.PageValueItem[(int)PageValue.SubConstractorName].Text = DetailList[0].CompanyName;
-                // 発注番号セット
-                inputpage.PageValueItem[(int)PageValue.OrdersNo].Text = string.Format("{0}-{1}", m_ConstructionCode, (PageCount + 1).ToString("000"));
-
-                int Linecnt = 0;
-                double TotalPrice = 0;
-                DataGridView dgv = inputpage.Group1DataGridView;
-                foreach (ConstructionBudgetDetail DetailRec in DetailList)
-                {
-                    // 15行以上は処理しない
-                    if(Linecnt > (dgv.RowCount-1)) break;
-                    DataGridViewRow CurRow = dgv.Rows[Linecnt];
-                    // 番号
-                    CurRow.Cells[(int)DispDetailGridColumn.No].Value = (Linecnt + 1);
-                    // グループ番号
-                    CurRow.Cells[(int)DispDetailGridColumn.GroupNo].Value = DetailRec.GroupCount;
-                    // 構成コード
-                    CurRow.Cells[(int)DispDetailGridColumn.ComponentCode].Value = DetailRec.ComponentCode;
-                    // 工種コード
-                    CurRow.Cells[(int)DispDetailGridColumn.ItemCode].Value = DetailRec.ItemCode;
-                    // 項目・品名
-                    CurRow.Cells[(int)DispDetailGridColumn.FirstName].Value = DetailRec.FirstString;
-                    // 内容内訳
-                    CurRow.Cells[(int)DispDetailGridColumn.SecondName].Value = DetailRec.SecondString;
-                    // 数量
-                    CurRow.Cells[(int)DispDetailGridColumn.Quantity].Value = 1;
-                    // 単位
-                    CurRow.Cells[(int)DispDetailGridColumn.UnitName].Value = "式";
-                    // 金額
-                    CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value = DetailRec.ExecutionAmount.ToString("#,0");
-                    TotalPrice += DetailRec.ExecutionAmount;
-                    Linecnt++;
-
-                    // 支払条件の初期設定
-                    if (!GetConstructionTypeToExecNo())
-                    {
-                        // 簡易版支払い条件セット
-                        InitGroupBox2(inputpage);
-                    }
-                    else
-                    {
-                        InitGroupBox3(inputpage);
-                    }
-                }
-
-                // 発注金額
-                inputpage.PageValueItem[(int)PageValue.OrderPrice].Text = TotalPrice.ToString("#,0");
-                // グリッド合計表示
-                inputpage.Group1Label.Text = inputpage.PageValueItem[(int)PageValue.OrderPrice].Text;
-                // 発注書作成日
-                inputpage.PageTextBox.Text = DateTime.Now.ToShortDateString();
-
-
-                return true;
-            }
-            catch (System.Exception ex)
-            {
-                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
-                return false;
-            }
-        }
-        #endregion
-
         #region 簡易版支払条件の初期値セット
         /// <summary>
         /// 簡易版支払条件の初期値セット
@@ -776,6 +1033,7 @@
         {
             IOPurchaseOrder OrderDB = new IOPurchaseOrder();
             IOPurchaseOrderDetail DetailDB = new IOPurchaseOrderDetail();
+            IOConstructionLedgerDetail LDetailDB = new IOConstructionLedgerDetail();
             try
             {
                 //データチェック
@@ -786,21 +1044,17 @@
 
                 OrderDB.connect(); OrderDB.beginTran();
                 DetailDB.connect(); DetailDB.beginTran();
+                LDetailDB.connect(); LDetailDB.beginTran();
 
-                // まず削除する
-                string strDel = OrderDB.CreatePrimarykeyString(m_ConstructionCode);
-                // 注文書データ削除
-                OrderDB.DeleteAction(strDel, false);
-                // 注文書明細データ削除
-                DetailDB.DeleteAction(strDel, false);
-
                 // データ登録
+                int SeqCnt = 0;
                 for (int i = 0; i < m_TabPageList.Count; i++)
                 {
                     PurchaseOrderInputPage DataTab = m_TabPageList[i];
+                    SeqCnt = DataTab.SeqNo;
 
                     // 注文書データ登録処理
-                    if (!EntryPurchaseOrder(ref OrderDB, DataTab, (i + 1)))
+                    if (!EntryPurchaseOrder(ref OrderDB, DataTab, SeqCnt))
                     {
                         OrderDB.rollback();
                         DetailDB.rollback();
@@ -808,16 +1062,26 @@
                     }
 
                     // 注文書明細データ登録処理
-                    if (!EntryPurchaseOrderDetail(ref DetailDB, DataTab, (i + 1)))
+                    if (!EntryPurchaseOrderDetail(ref DetailDB, DataTab, SeqCnt))
                     {
                         OrderDB.rollback();
                         DetailDB.rollback();
                         return false;
                     }
+
+                    // 工事台帳の注文書作成フラグ更新
+                    if (!UpdateLedgerDetail(LDetailDB, DataTab, SeqCnt))
+                    {
+                        OrderDB.rollback();
+                        DetailDB.rollback();
+                        LDetailDB.rollback();
+                        return false;
+                    }
                 }
 
                 OrderDB.commit();
                 DetailDB.commit();
+                LDetailDB.commit();
 
                 // フラグクリア
                 m_bChengeAns = false;
@@ -833,6 +1097,7 @@
             {
                 OrderDB.close(); OrderDB = null;
                 DetailDB.close(); DetailDB = null;
+                LDetailDB.close(); LDetailDB = null;
             }
         }
         #endregion
@@ -847,7 +1112,7 @@
             bool bRet = true;
             bool bPageAns = true;
             PurchaseOrderInputPage errPage = null;
-            IOConstructionBudgetDetail DetailDB = new IOConstructionBudgetDetail();
+            IOConstructionLedger LedgerDB = new IOConstructionLedger();
             try
             {
                 foreach (PurchaseOrderInputPage CurPage in m_TabPageList)
@@ -862,16 +1127,13 @@
                     bPageAns &= CommonMotions.DispFieldDateCheck(CurPage.Group1TextBox);
 
                     //// 注文書データ読込
-                    string strSQL = "SELECT SUM(EXECUTIONAMOUNT) FROM CONSTRUCTIONBUDGETDETAIL";
-                    strSQL += DetailDB.CreatePrimarykeyString(m_ConstructionCode);
-                    strSQL += string.Format("AND COMPANYCODE = {0}", CurPage.OrderCompanyCode);
-                    ArrayList arList = new ArrayList();
-                    if (!DetailDB.ExecuteReader(strSQL, ref arList)) continue;
-                    object[] objList = (object[])arList[0];
+                    string strSQL = LedgerDB.CreatePrimarykeyString(m_ConstructionCode);
+                    ConstructionLedger LedgerRec = new ConstructionLedger();
+                    if (!LedgerDB.SelectAction(strSQL, ref LedgerRec)) continue;
 
                     // 発注金額・合計金額のチェック(入力金額が大きくなった場合はエラー)
                     bool bNotErr = true;
-                    if (CommonMotions.cnvDouble(objList[0]) < CommonMotions.cnvDouble(CurPage.Group1Label.Text))
+                    if (LedgerRec.OrdersDecisionPrice < CommonMotions.cnvDouble(CurPage.Group1Label.Text))
                     {
                         bNotErr = false;
                         bPageAns = false;
@@ -1060,7 +1322,7 @@
             }
             finally
             {
-                DetailDB.close(); DetailDB = null;
+                LedgerDB.close(); LedgerDB = null;
             }
         }
         #endregion
@@ -1085,49 +1347,55 @@
         /// 注文書データの登録処理
         /// </summary>
         /// <returns></returns>
-        private bool EntryPurchaseOrder(ref IOPurchaseOrder OrderDB, PurchaseOrderInputPage DataTab, int Datacnt)
+        private bool EntryPurchaseOrder(ref IOPurchaseOrder OrderDB, PurchaseOrderInputPage DataTab, int SeqNo)
         {
             try
             {
+                // データ存在確認
+                bool DataExists = false;
+                PurchaseOrder DataRec = new PurchaseOrder();
+                string strSQL = OrderDB.CreatePrimarykeyString(m_ConstructionCode, SeqNo);
+                if (OrderDB.SelectAction(strSQL, ref DataRec, false)) DataExists = true;
+
+                if (!DataExists)
+                {
+                    DataRec.ConstructionCode = m_ConstructionCode;                                  // 工事番号
+                    DataRec.SeqNo = SeqNo;                                                          // 注文書枝番
+                }
+
                 // データセット
-                PurchaseOrder DataRec = new PurchaseOrder();
+                DataRec.CompanyCode = DataTab.OrderCompanyCode;                                                         // 協力会社コード
+
+                DataRec.CreateDate = CommonMotions.cnvDate(DataTab.PageTextBox.Text);                                   // 作成日付
                 
-                DataRec.ConstructionCode = m_ConstructionCode;                                      // 工事番号
-                
-                DataRec.SeqNo = Datacnt;                                                            // 注文書枝番
-                
-                DataRec.CompanyCode	= DataTab.OrderCompanyCode;                                     // 協力会社コード
-                
-                DataRec.CreateDate = CommonMotions.cnvDate(DataTab.PageTextBox.Text);               // 作成日付
-                
                 DataRec.OrderPrice = CommonMotions.cnvDouble(DataTab.PageValueItem[(int)PageValue.OrderPrice].Text);    // 発注金額
 
-                DataRec.LastRowStringDate = CommonMotions.cnvDate(DataTab.Group1TextBox.Text);      // 最終行表示日付
+                DataRec.LastRowStringDate = CommonMotions.cnvDate(DataTab.Group1TextBox.Text);                          // 最終行表示日付
 
                 // 簡易版と正規版では登録内容が違う
                 if (radioButton1.Checked)
                 {   // 簡易版データ
-                    DataRec.OrderSheetType = (int)CommonDefine.OrderSheetType.SimpleType;                        // 簡易・本式フラグ
+                    DataRec.OrderSheetType = (int)CommonDefine.OrderSheetType.SimpleType;                               // 簡易・本式フラグ
 
                     if (DataTab.Group2RadioButton[(int)Group2CheckBox.Chk1].Checked)
-                        DataRec.PaymentTerms = (int)Group2CheckBox.Chk1;                            // 支払い条件
+                        DataRec.PaymentTerms = (int)Group2CheckBox.Chk1;                                                // 支払い条件
                     else
-                        DataRec.PaymentTerms = (int)Group2CheckBox.Chk2;                            // 支払い条件
+                        DataRec.PaymentTerms = (int)Group2CheckBox.Chk2;                                                // 支払い条件
 
-                    DataRec.CashRatio = CommonMotions.cnvDouble(DataTab.Group2TextBox[(int)Group2Item.CachRatio].Text);     // 現金割合（％）
+                    DataRec.CashRatio = CommonMotions.cnvDouble(DataTab.Group2TextBox[(int)Group2Item.CachRatio].Text); // 現金割合（％）
                 }
                 else
                 {   // 正規版データ
-                    DataRec.OrderSheetType = (int)CommonDefine.OrderSheetType.RegularType;                       // 簡易・本式フラグ
+                    DataRec.OrderSheetType = (int)CommonDefine.OrderSheetType.RegularType;                              // 簡易・本式フラグ
 
                     if (DataTab.Group3CheckBox[(int)Group3CheckBox.Previous].Checked) {
-                        DataRec.PrePayments = 1;                                                    // 前金払
+                        DataRec.PrePayments = 1;                                                                        // 前金払
                         DataRec.PrePaymentsDays	= CommonMotions.cnvInt(DataTab.Group3TextBox[(int)Group3TextBox.PrePaymentsDays].Text);         // 前金払日数
                         DataRec.PrePaymentsPrice = CommonMotions.cnvDouble(DataTab.Group3TextBox[(int)Group3TextBox.PrePaymentsPrice].Text);    // 前金払金額
                     }
                     if (DataTab.Group3CheckBox[(int)Group3CheckBox.Partial].Checked)
                     {
-                        DataRec.PartialPayment = 1;                                                 // 部分払
+                        DataRec.PartialPayment = 1;                                                                     // 部分払
                         DataRec.PartialPaymentMounth = CommonMotions.cnvInt(DataTab.Group3TextBox[(int)Group3TextBox.PartialPaymentMounth].Text);   // 部分払締切月
                         DataRec.PartialPaymentDay1 = CommonMotions.cnvInt(DataTab.Group3TextBox[(int)Group3TextBox.PartialPaymentDay1].Text);       // 部分払締切日
                         DataRec.PartialPaymentDay2 = CommonMotions.cnvInt(DataTab.Group3TextBox[(int)Group3TextBox.PartialPaymentDay2].Text);       // 部分払支払日
@@ -1135,7 +1403,7 @@
                     }
                     if (DataTab.Group3CheckBox[(int)Group3CheckBox.Complete].Checked)
                     {
-                        DataRec.CompletionPayment = 1;	                                            // 引渡し時の支払
+                        DataRec.CompletionPayment = 1;	                                                                // 引渡し時の支払
                         DataRec.CompletionPaymentDays = CommonMotions.cnvInt(DataTab.Group3TextBox[(int)Group3TextBox.CompletionPaymentDays].Text);	// 引渡し時の支払日数
                         DataRec.CompletionPaymentPrice = CommonMotions.cnvDouble(DataTab.Group3TextBox[(int)Group3TextBox.CompletionPaymentPrice].Text);    // 引渡し時の支払金額
                     }
@@ -1151,12 +1419,24 @@
                     DataRec.WorkersCount = CommonMotions.cnvInt(DataTab.Group5TextBox.Text);                                                    // 作業員数
                 }
 
-                // データ登録
-                if (!OrderDB.InsertAction(DataRec, false))
+                if (DataExists)
                 {
-                    LogicalErrorMessage("注文書データ：登録に失敗しました。", "登録エラー", CommonMotions.GetMethodName());
-                    return false;
+                    // データ更新
+                    if (!OrderDB.UpdateAction(strSQL, DataRec, false))
+                    {
+                        LogicalErrorMessage("注文書データ：更新に失敗しました。", "更新エラー", CommonMotions.GetMethodName());
+                        return false;
+                    }
                 }
+                else
+                {
+                    // データ登録
+                    if (!OrderDB.InsertAction(DataRec, false))
+                    {
+                        LogicalErrorMessage("注文書データ：登録に失敗しました。", "登録エラー", CommonMotions.GetMethodName());
+                        return false;
+                    }
+                }
 
                 return true;
             }
@@ -1173,10 +1453,14 @@
         /// 注文書明細データの登録処理
         /// </summary>
         /// <returns></returns>
-        private bool EntryPurchaseOrderDetail(ref IOPurchaseOrderDetail DetailDB, PurchaseOrderInputPage DataTab, int Datacnt)
+        private bool EntryPurchaseOrderDetail(ref IOPurchaseOrderDetail DetailDB, PurchaseOrderInputPage DataTab, int SeqNo)
         {
             try
             {
+                // データ削除
+                string strSQL = DetailDB.CreatePrimarykeyString(m_ConstructionCode, SeqNo);
+                DetailDB.DeleteAction(strSQL, false);
+
                 // 明細グリッド書込み
                 for (int i = 0; i < DataTab.Group1DataGridView.RowCount; i++)
                 {
@@ -1186,10 +1470,10 @@
                         CommonMotions.cnvString(GetRow.Cells[(int)DispDetailGridColumn.SecondName].Value).Length == 0) continue;
 
                     PurchaseOrderDetail DatailRec = new PurchaseOrderDetail();
-                    DatailRec.ConstructionCode = m_ConstructionCode;	// 工事番号
-                    DatailRec.SeqNo = Datacnt;                          // 注文書枝番
-                    DatailRec.GroupCount = 0;                           // グループ番号
-                    DatailRec.LineCount = (i + 1);                      // 行番号
+                    DatailRec.ConstructionCode = m_ConstructionCode;	                                                            // 工事番号
+                    DatailRec.SeqNo = SeqNo;                                                                                        // 注文書枝番
+                    DatailRec.GroupCount = 0;                                                                                       // グループ番号
+                    DatailRec.LineCount = (i + 1);                                                                                  // 行番号
                     DatailRec.ComponentCode = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.ComponentCode].Value);    // 構成キー
                     DatailRec.ItemCode = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.ItemCode].Value);              // 工種キー
                     DatailRec.FirstString = CommonMotions.cnvString(GetRow.Cells[(int)DispDetailGridColumn.FirstName].Value);       // 工種・品名
@@ -1198,6 +1482,7 @@
                     DatailRec.UnitName = CommonMotions.cnvString(GetRow.Cells[(int)DispDetailGridColumn.UnitName].Value);           // 単位
                     DatailRec.UnitPrice = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.UnitPrice].Value);	        // 単価
                     DatailRec.OrdersLinePrice = CommonMotions.cnvDouble(GetRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);  // 金額
+                    DatailRec.SourceCode = CommonMotions.cnvInt(GetRow.Cells[(int)DispDetailGridColumn.SourceCode].Value);          // 元工事番号
 
                     // データ書込み
                     if (!DetailDB.InsertAction(DatailRec, false)) return false;
@@ -1222,11 +1507,11 @@
                     if (GetRow.ReadOnly) continue;
 
                     PurchaseOrderDetail DatailRec = new PurchaseOrderDetail();
-                    DatailRec.ConstructionCode = m_ConstructionCode;	// 工事番号
-                    DatailRec.SeqNo = Datacnt;                          // 注文書枝番
-                    DatailRec.GroupCount = GroupCount;                  // グループ番号
-                    DatailRec.LineCount = (i + 1);                      // 行番号
-                    DatailRec.FirstString = CommonMotions.cnvString(GetRow.Cells[(int)DispTermsGridColumn.Terms].Value);     // 条件文字列
+                    DatailRec.ConstructionCode = m_ConstructionCode;	                                                    // 工事番号
+                    DatailRec.SeqNo = SeqNo;                                                                                // 注文書枝番
+                    DatailRec.GroupCount = GroupCount;                                                                      // グループ番号
+                    DatailRec.LineCount = (i + 1);                                                                          // 行番号
+                    DatailRec.FirstString = CommonMotions.cnvString(GetRow.Cells[(int)DispTermsGridColumn.Terms].Value);    // 条件文字列
 
                     // データ書込み
                     if (!DetailDB.InsertAction(DatailRec, false))
@@ -1249,6 +1534,119 @@
         }
         #endregion
 
+        #region 工事台帳更新処理
+        /// <summary>
+        /// 工事台帳更新処理
+        /// </summary>
+        /// <returns></returns>
+        private bool UpdateLedgerDetail(IOConstructionLedgerDetail LDetailDB, PurchaseOrderInputPage DataTab, int SeqNo)
+        {
+            try
+            {
+                int QuantityVal = 0;
+                int PriceVal = 0;
+                int LedgerLine = 0;
+                bool ChangeCompany = false;
+                int BeforeCode = 0;
+                string strSQL = string.Empty;
+                int TargetCode = ClsProcessExist.GetParentConstrCode(m_ConstructionCode);
+                int TargetField = 0;
+
+                // 協力会社の変更チェック
+                ChangeCompany = ChangeCompanyTab(DataTab, ref  BeforeCode);
+
+                DataGridView dgv = DataTab.Group1DataGridView;
+                foreach (DataGridViewRow CurRow in dgv.Rows)
+                {
+                    // 数量
+                    QuantityVal = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.Quantity].Value);
+                    // 金額
+                    PriceVal = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.PriceValue].Value);
+                    // 工事台帳行
+                    LedgerLine = CommonMotions.cnvInt(CurRow.Cells[(int)DispDetailGridColumn.LedgerLine].Value);
+                    // 数量金額無は処理しない
+                    if (QuantityVal == 0 && PriceVal == 0) continue;
+
+                    // 変更がある場合は協力会社を変更する
+                    if (ChangeCompany)
+                    {
+                        // 協力会社名変更
+                        TargetField = (int)IOConstructionLedgerDetail.DataColumn.CompanyName;
+                        strSQL = LDetailDB.CreatePrimarykeyString(TargetCode);
+                        strSQL += string.Format(" AND SOURCECODE = {0}", m_ConstructionCode);
+                        strSQL += string.Format(" AND GROUPCOUNT = {0}", (int)FrmConstructionLedger.DataGroup.ConstructionCosts);
+                        strSQL += string.Format(" AND COMPANYCODE = {0}", BeforeCode);
+                        strSQL += string.Format(" AND EXECUTIONAMOUNT = {0}", PriceVal);
+                        if (LedgerLine != 0) strSQL += string.Format(" AND LINECOUNT = {0}", LedgerLine);
+                        if (!LDetailDB.UpdateFeild(strSQL, TargetField, DataTab.EntryTab.Text, false))
+                        {
+                            LDetailDB.rollback();
+                            return false;
+                        }
+                        // 協力会社コード変更
+                        TargetField = (int)IOConstructionLedgerDetail.DataColumn.CompanyCode;
+                        if (!LDetailDB.UpdateFeild(strSQL, TargetField, DataTab.OrderCompanyCode, false))
+                        {
+                            LDetailDB.rollback();
+                            return false;
+                        }
+                    }
+                    // 注文書作成フラグON
+                    TargetField = (int)IOConstructionLedgerDetail.DataColumn.PurchaseOrderFlg;
+                    strSQL = LDetailDB.CreatePrimarykeyString(TargetCode);
+                    strSQL += string.Format(" AND SOURCECODE = {0}", m_ConstructionCode);
+                    strSQL += string.Format(" AND GROUPCOUNT = {0}", (int)FrmConstructionLedger.DataGroup.ConstructionCosts);
+                    strSQL += string.Format(" AND COMPANYCODE = {0}", DataTab.OrderCompanyCode);
+                    strSQL += string.Format(" AND EXECUTIONAMOUNT = {0}", PriceVal);
+                    if (LedgerLine != 0) strSQL += string.Format(" AND LINECOUNT = {0}", LedgerLine);
+                    if (!LDetailDB.UpdateFeild(strSQL, TargetField, 1, false))
+                    {
+                        LDetailDB.rollback();
+                        return false;
+                    }
+                }
+
+                LDetailDB.commit();
+
+                return true;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 協力会社変更確認
+        /// <summary>
+        /// 協力会社変更確認
+        /// </summary>
+        /// <returns></returns>
+        private bool ChangeCompanyTab(PurchaseOrderInputPage DataTab, ref int BeforeCode)
+        {
+            try
+            {
+                bool bMatch = false;
+                // 変更リストを検索する
+                foreach (KeyValuePair<int, int> CurVal in m_ChangeCompany)
+                {
+                    if (DataTab.OrderCompanyCode != CurVal.Value) continue;
+                    bMatch = true;
+                    BeforeCode = CurVal.Key;
+                    break;
+                }
+
+                return bMatch;
+            }
+            catch (System.Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+                return false;
+            }
+        }
+        #endregion
+
         #region データ削除処理
         /// <summary>
         /// 削除ボタン押下後の削除処理
@@ -1269,7 +1667,7 @@
                 OrderDB.connect(); OrderDB.beginTran();
                 DetailDB.connect(); DetailDB.beginTran();
 
-                // まず削除する
+                // 削除する
                 string strDel = OrderDB.CreatePrimarykeyString(m_ConstructionCode);
                 if (!OrderDB.DeleteAction(strDel, false))
                 {
@@ -1366,7 +1764,7 @@
                 btnPetition.Size = new Size(250, btnPetition.Size.Height);
 
                 // ----- 工事コード・承認機能番号取得（申請レコードがなお場合は未申請）
-                if (!ClsApprovalPermission.CheckPetition(m_ConstructionCode, iApprovalCode)) return;
+                if (!ClsApprovalPermission.CheckPetition(m_ConstructionCode, iApprovalCode, m_OrderNo)) return;
 
                 // ----- 申請済の場合
                 // 申請ボタンの表示
@@ -1379,7 +1777,7 @@
                 btnApproval.Visible = true;
 
                 // ----- 承認済の場合
-                if (ClsApprovalPermission.CheckApproval(m_ConstructionCode, iApprovalCode))
+                if (ClsApprovalPermission.CheckApproval(m_ConstructionCode, iApprovalCode, m_OrderNo))
                 {
                     btnApproval.Text = CommonDefine.ApprovalButtonString[1];
                     btnApproval.ForeColor = Color.Black;
@@ -1401,7 +1799,7 @@
 
         #region 書込み禁止処理
         /// <summary>
-        /// 予算入力を変更禁止にする
+        /// 入力を変更禁止にする
         /// </summary>
         private void DisplayReadOnly()
         {
